<?php

/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

	# email daemon

	# only one email daemon may run at once.  It is not multi-process safe.
	# to make it multi-process safe, add appropriate lock table and unlock table statements

	require_once ("../framework/includes.php");

	# do not cache sql results
	define ('DO_CACHING_OVERRIDE', true);

	while (1) {

		$SQL = "SELECT * FROM framework_email WHERE sent=0 AND when_to_send < NOW() ORDER BY when_to_send ASC LIMIT 10";
		$result = sql_query_read($SQL);

		if (sql_num_rows($result) > 0) {
			
			# make a big array of emails to send
			$ids = array();
			$emails = array();
			
			while ($row = sql_fetch_array($result)) {
				$ids[] = $row["email_id"];
				$emails[] = $row;
			}

			$SQL = "UPDATE framework_email SET sent=1 WHERE email_id IN (".join(",",$ids).")";
			sql_query_write($SQL);

			debug_print("Setting (".join(",",$ids).") as sent\n");

			foreach ($emails as $key => $value) {
				# database -> plaintext email, no need to clean
				$to = $value["to_email"];
				$subject = $value["subject"];
				$body = $value["body"];
				
				if (!$value["from"]) {
					$value["from"] = "domains@gavintech.com";
				}
				
				if ($value["headers"]) {
					$head = str_replace("\r","",$value["headers"]);
					$head = split("\n",$head);
					
					$headers = "From: ".$value["from_email"]."\r\n".join("\r\n",$head);
				} else {
					$headers = "From: ".$value["from_email"];
				}

				$headers .= "\r\nDate: ".date('r');

				debug_print("Mailing $to\n");

				mail ($to, $subject, $body, $headers);
			}

			$SQL = "DELETE FROM framework_email WHERE email_id IN (".join(",",$ids).")";
			sql_query_write($SQL);
			
			debug_print("Deleting (".join(",",$ids).")\n");
		}

		# wait a second before starting the whole thing over again
		sleep(1);
	}

?>
