<?php
/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

require_login(AUTH_USER);

# cart operations

$done = array();

if (is_array($_REQUEST["delete"]) && count($errors) == 0) {
	require_validator("cart.php");
	
	foreach ($_REQUEST["delete"] as $key => $value) {	
		# get the item to delete
		$SQL = "SELECT name, key_row, id FROM cart INNER JOIN cart_table USING (table_id) WHERE cart_id = $key";
		$result = sql_query_read($SQL);
		
		if (sql_num_rows($result) > 0) {
			$row = sql_fetch_array($result);
			
			# also kill the description in the extra info table
			$SQL = "DELETE FROM ".clean_sql_sql($row["name"])." WHERE ".clean_sql_sql($row["key_row"])."=".$row["id"]." AND is_ordered=0";
			sql_query_write($SQL);
			
			$SQL = "DELETE FROM cart WHERE cart_id=$key";
			sql_query_write($SQL);
			
			array_push($done, "Deleted item");
		}
	}
}

if ($_REQUEST["clear"]) {
	# get all items in the cart
	$SQL = "SELECT name, cart_id, key_row, id FROM cart INNER JOIN cart_table USING (table_id) WHERE user_id = ".$_SESSION["user_id"];
	$result = sql_query_read($SQL);
	
	# if there are items, kill them
	if (sql_num_rows($result) > 0) {
		while ($row = sql_fetch_array($result)) {
			# also kill the description in the extra info table
			$SQL = "DELETE FROM ".clean_sql_sql($row["name"])." WHERE ".clean_sql_sql($row["key_row"])."=".$row["id"]." AND is_ordered=0";
			sql_query_write($SQL);
			
			$SQL = "DELETE FROM cart WHERE cart_id=".$row["cart_id"];
			sql_query_write($SQL);
		}
		array_push($done, "Cleared cart");
	}
}

if ($_REQUEST["update"] && count($errors) == 0) {
	# get all items in the cart
	$SQL = "SELECT cart_id, name, key_row, id FROM cart INNER JOIN cart_table USING (table_id) WHERE user_id = ".$_SESSION["user_id"];
	$result = sql_query_read($SQL);
	
	# if there are items, update them
	if (sql_num_rows($result) > 0) {
		while ($row = sql_fetch_array($result)) {
			$SQL = "UPDATE ".clean_sql_sql($row["name"])." SET quantity=".$_REQUEST["quantity"][$row["cart_id"]]." WHERE ".clean_sql_sql($row["key_row"])."=".$row["id"];
			sql_query_write($SQL);
		}
		array_push($done, "Updated cart");
	}
}

?>

<h1>Shopping cart</h1>

<?php

print_errors();

# print messages if we accomplished anything
if (count($done) > 0) {
	echo ("<h2>Success</h2>\n");
	echo ("<p>The following actions were performed</p>\n<ul>\n");
	foreach ($done as $key => $value) {
		echo ("<li>$value</li>");
	}
	echo ("</ul>\n");
}

# get the items in the cart
$SQL = "SELECT cart_id, id, name, key_row, details_page
	FROM cart
	INNER JOIN cart_table USING (table_id)
	WHERE user_id = ".$_SESSION["user_id"];
$result = sql_query_read($SQL);

$array = array();

$total = 0;

# paginate them
while ($row = sql_fetch_array($result)) {
	# we need specific info from the corresponding table
	$SQL = "SELECT price, name, quantity
		FROM ".clean_sql_sql($row["name"])."
		WHERE ".clean_sql_sql($row["key_row"])."=".clean_sql_sql($row["id"]);
	$result2 = sql_query_read($SQL);
	$row2 = sql_fetch_array($result2);

	$array2 = array();
	$array2["Name"] = clean_sql_display($row2["name"]);
	$array2["Unit Price"][0] = clean_sql_display($row2["price"]);
	$array2["Unit Price"][1] = "$".clean_sql_display($row2["price"]);
	$array2["Quantity"][0] = $row2["quantity"];
	$array2["Quantity"][1] = "<input type=\"text\" name=\"quantity[".$row["cart_id"]."]\" value=\"".clean_sql_form($row2["quantity"])."\" />";
	$price = $row2["price"] * $row2["quantity"];
	$array2["Price"][0] = $price;
	$array2["Price"][1] = "$".number_format($price, 2, ".", "");
	$array2[1] = "<a href=\"index.php?next_page=".$row["details_page"]."&amp;".$row["key_row"]."=".$row["id"]."\">Details</a>";
	$array2[2] = "<input type=\"submit\" name=\"delete[".$row["cart_id"]."]\" value=\"Delete\" />";

	$array[] = $array2;

	$total += $price;

}

?>

<form action="index.php" method="post">
<input type="hidden" name="next_page" value="cart.php" />
<input type="hidden" name="validator" value="cart.php" />

<?php

if (count($array) > 0) {
	paginate($array);

?>

<p>Total: $<?=number_format($total, 2, ".", "")?></p>

<table width="100%">
<tr>
<td width="33%" align="left">
<input type="submit" name="update" value="Update cart" />
</form>
</td>
<td width="34%" align="center">
<form action="index.php" method="post">
<input type="hidden" name="next_page" value="cart.php" />
<input type="submit" name="clear" value="Clear cart" />
</form>
</td>
<td width="33%" align="right">

<?php
if (IS_PRODUCTION) {
?>

<form action="https://www.paypal.com/cgi-bin/webscr" method="post">

<input type="hidden" name="cmd" value="_xclick">
<input type="hidden" name="business" value="<?=PAYPAL_ACCOUNT?>" />
<input type="hidden" name="item_name" value="Gavintech Framework Shopping Cart" />
<input type="hidden" name="currency_code" value="CAD" />
<input type="hidden" name="amount" value="<?=$total?>" />
<input type="hidden" name="no_shipping" value="1" />
<input type="hidden" name="no_note" value="1" />
<input type="hidden" name="return" value="<?=($_SERVER["SERVER_PORT"] == 80 ? "http" : "https")?>://<?=$_SERVER["SERVER_NAME"]?><?=$_SERVER["PHP_SELF"]?>?next_page=cart_complete.php&item_number=<?=($total * 100)?>" />
<?php
} else {
?>
<form action="index.php" method="post">
<input type="hidden" name="next_page" value="cart.php" />
<?php
}
?>
<input type="hidden" name="item_number" value="<?=($total * 100)?>" />
<input type="submit" name="complete" value="Check out" />
</form>
</td>
</tr>
</table>

<?php
} else {
	print "<p><i>Your shopping cart is empty!</i></p>";      
} # if count($array) > 0
?>

</form>

