<?php
/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

require_login(AUTH_USER);

# cart operations

if ($_REQUEST["done"] == true) {

?>

<h1>Thank you!</h1>

<?php

	print_errors();
	echo ("<p>Your order has been completed successfully.  A Gavintech representative will contact you shortly with more information.</p>");

} else {

	print_errors();

	# get the items in the cart
	$SQL = "SELECT cart_id, id, name, key_row
		FROM cart
		INNER JOIN cart_table USING (table_id)
		WHERE user_id = ".$_SESSION["user_id"];
	$result = sql_query_read($SQL);

	$array = array();

	$total = 0;

	while ($row = sql_fetch_array($result)) {
		# we need specific info from the corresponding table
		$SQL = "SELECT price, name, quantity
			FROM ".clean_sql_sql($row["name"])."
			WHERE ".clean_sql_sql($row["key_row"])."=".clean_sql_sql($row["id"]);
		$result2 = sql_query_read($SQL);
		$row2 = sql_fetch_array($result2);

		$price = $row2["price"] * $row2["quantity"];

		$total += $price;
	}

	if ($total > 0 && $total == ($_REQUEST["item_number"]/100)) {

		# get all items in the cart
		$SQL = "SELECT name, cart_id, key_row, id, user_type FROM cart INNER JOIN cart_table USING (table_id) WHERE user_id = ".$_SESSION["user_id"];
		$result = sql_query_read($SQL);

		$email_message = "A new Gavintech order has just been completed for user ".clean_form_sql($_SESSION["user_name"])."\n\nOrder:\n\n";
		
		# kill them, and mark the items as ordered.
		if (sql_num_rows($result) > 0) {
			while ($row = sql_fetch_array($result)) {
				# set is_ordered to true
				$SQL = "UPDATE ".clean_sql_sql($row["name"])." SET is_ordered=1 WHERE ".clean_sql_sql($row["key_row"])."=".$row["id"];
				sql_query_write($SQL);
				# if we're supposed to add the user to a group
				# because they ordered something, do it here
				if ($row["user_type"] > 0) {
					add_user_type($row["user_type"]);
				}
				# generate an email for the cart notify email
				$SQL = "SELECT name, quantity, price FROM ".clean_sql_sql($row["name"])." WHERE ".clean_sql_sql($row["key_row"])."=".$row["id"];
				$result2 = sql_query_read($SQL);
				$row2 = sql_fetch_array($result2);

				$email_message .= clean_sql_sql($row2["name"])." (".$row["id"].") x".$row2["quantity"]." - $".$row2["price"]." each\n";

				$SQL = "DELETE FROM cart WHERE cart_id=".$row["cart_id"];
				sql_query_write($SQL);
			}
		}

		email(MACHINES_NOTIFY_EMAIL, "New Gavintech checkout", $email_message);

		header("Location: index.php?next_page=cart_complete.php&done=true");
		
	} else {
?>
<h1>Error!</h1>
<p>A problem occured when checking out.  A Gavintech representative will contact you shortly to correct the problem.</p>

<?php
	}
}
?>

