<h1>How to Draw a Graph</h1>

<h2>Setting up the array</h2>

<p>The general structure of the graph array is as follows:</p>

<pre>
$graph[0]["data"] = array(values);
$graph[0]["colour"] = array("r" => #, "g" => #, "b" => #);
$graph[0]["legend"] = "Name of the series";
$graph[1]...[n] same as above

$graph["metadata"]["title"] = "Graph title";
$graph["metadata"]["bgcolour"] = array("r" => #, "g" => #, "b" => #);
$graph["metadata"]["xsize"] = (width of the chart);
$graph["metadata"]["ysize"] = (height of the chart);
$graph["metadata"]["ymin"] = (what number to start with at the bottom of the graph);
$graph["metadata"]["ymax"] = (what number to end with at the top of the graph);
$graph["metadata"]["show_legend"] = (0 - don't show, 1 - show);
$graph["metadata"]["show_gridlines"] = (0 - don't show, positive number - the number of gridlines);
$graph["metadata"]["show_proctime"] = (0 - don't show, 1 - show);
$graph["metadata"]["show_gentime"] = (0 don't show, 1 - show);
</pre>

<h2>Graphing</h2>

<p>To actually draw the graph, call draw_graph($graph).</p>

<h2>Sample</h2>

<p>See the source code for this page to see how the graph was generated.</p>

<?php

$graph = array();

$array = array();
$array["data"] = array(1, 1, 2, 3, 5, 8, 13, 21, 34, 55);
$array["colour"] = array("r" => 202, "g" => 167, "b" => 22);
$array["legend"] = "Fibonacci";
$graph[] = $array;

$array = array();
$array["data"] = array(1, 4, 9, 16, 25, 36, 49, 64, 81, 100);
$array["colour"] = array("r" => 245, "g" => 141, "b" => 124);
$array["legend"] = "Squares";
$graph[] = $array;

$array = array();
$array["data"] = array(1, 8, 28, 56, 70, 56, 28, 8, 1);
$array["colour"] = array("r" => 1, "g" => 61, "b" => 4);
$array["legend"] = "Pascal(9)";
$graph[] = $array;

$graph["metadata"]["title"] = "Three Mathematical Series";
$graph["metadata"]["bgcolour"] = array("r" => 200, "g" => 200, "b" => 200);
$graph["metadata"]["xsize"] = 500;
$graph["metadata"]["ysize"] = 300;
$graph["metadata"]["ymin"] = 0;
$graph["metadata"]["ymax"] = 100;
$graph["metadata"]["show_legend"] = 1;
$graph["metadata"]["show_gridlines"] = 4;
$graph["metadata"]["show_proctime"] = 1;
$graph["metadata"]["show_gentime"] = 1;

echo ("<p>");
draw_graph($graph);
echo ("</p>");

?>
